;----------------------------------------------------------------------
; command line arguments
;    2000/ 4/24   cmdline.asm
;
;     Copyright (C) 2000 Jun Mizutani  <mizutani.jun@nifty.ne.jp>
;
; usage : cmdline abcd  lkl  k   p
;
; No. of Argument <Stack top> : 5
; Program Name : ./cmdline
; Argument #1 Address : BFFFFCCF   Argument String : abcd
; Argument #2 Address : BFFFFCD4   Argument String : lkl
; Argument #3 Address : BFFFFCD8   Argument String : k
; Argument #4 Address : BFFFFCDA   Argument String : p
;

%include "stdio.inc"

section .text
global _start

m_argc     db    " No. of Argument <Stack top> : ", 0
m_cmd      db    " Program Name : ", 0
m_args     db    " Argument #", 0
m_args2    db    " Address : ", 0
m_arg_c    db    "   Argument String : ", 0

_start:
        call    NewLine
        mov     eax, m_argc
        call    OutAsciiZ
        pop     eax             ; ο argc
        call    PrintLeft
        call    NewLine
        dec     eax             ; ºݤΰο
        pop     ebx             ; ޥ̾

        mov     eax, m_cmd
        call    OutAsciiZ
        mov     eax, ebx
        call    OutAsciiZ       ; ޥ̾ɽ
        call    NewLine

        xor     ebx, ebx
.next_arg:
        inc     ebx
        pop     edi             ; pop filename pointer
        or      edi, edi        ; check null pointer
        jz      .done           ; end of args processing
        mov     eax, m_args
        call    OutAsciiZ
        mov     eax, ebx
        call    PrintLeft
        mov     eax, m_args2
        call    OutAsciiZ
        mov     eax, edi
        call    PrintHex8
        mov     eax, m_arg_c
        call    OutAsciiZ
        mov     eax, edi
        call    OutAsciiZ       ; ɽ
        call    NewLine         ; 
        jmp short .next_arg     ; try next arg

.noarg
.done
        call    NewLine         ; 
        call    Exit
