;-------------------------------------------------------------------------
;  file : fbinfo.asm
;  2001/02/21
;  Copyright (C) 2001  Jun Mizutani <mizutani.jun@nifty.ne.jp>
;-------------------------------------------------------------------------

global _start

%include    "fb.inc"
%include    "stdio.inc"
%include    "fblib.inc"
%include    "printfb.inc"

;==============================================================
section .text
_start:
                call    fbdev_open
                js      near  fb_error
                call    fb_get_fscreen
                call    PrintFBFixScreenInfo
                call    fb_get_screen
                js      near  fb_error
                call    fb_copy_scinfo
                call    PrintFBScreenInfo
                call    Exit

fb_error:
                mov     eax, fberr_msg
                call    OutAsciiZ
                call    Exit

fberr_msg       db 'frabe buffer error!', 10, 0

