;---------------------------------------------------------------------
;   Frame buffer
;   2001/02/22 Jun Mizutani
;   fbtest.asm
;---------------------------------------------------------------------
%include        "stdio.inc"
%include        "fblib.inc"

%assign O_RDONLY             00q

;==============================================================
section .text
global _start

_start:
        ;-------------------------------------------
        ; ե졼Хåեν
        ;-------------------------------------------
                call    fbdev_open          ; /dev/fb0 򥪡ץ
                js      near .fb_Error
                call    fb_get_screen       ; ꡼
                js      .fb_Error
                call    fb_copy_scinfo      ; scinfo_data 
                call    fb_map_screen       ; ˥ޥåԥ
                js      .fb_Error
                mov     [fb_mem], eax       ; Ƭɥ쥹
                mov     edi, [fb_mem]
                mov     ebx, [mmap_arg.len] ; 
        ;-------------------------------------------
        ; [edi]  [edi+ebx-1] ϰϤ˽񤭹
        ;-------------------------------------------
                call    OpenRandom
                shr     ebx, 1
                mov     ecx, 10000
    .loop:      call    GetRandom
                xor     edx, edx
                div     ebx
                mov     [edi+edx*2], dx     ; Ǥ
                loop    .loop
                call    CloseRandom
                xor     esi, esi
                mov     ecx, ebx
                shr     ecx, 1
    .loop2:     mov     eax, [edi+esi*4]    ; ɤ߽Ф
                xor     eax, 0x55555555
                mov     [edi+esi*4], eax    ; ̽񤭹
                inc     esi
                loop    .loop2
                xor     esi, esi
                mov     ecx, ebx
                shr     ecx, 1
    .loop3:     mov     eax, [edi+esi*4]    ; ɤ߽Ф
                xor     eax, 0x55555555
                mov     [edi+esi*4], eax    ; ̽񤭹
                inc     esi
                loop    .loop3
        ;-------------------------------------------
        ; ե졼Хåեθ
        ;-------------------------------------------
    .exit       call    fb_unmap_screen
                call    fbdev_close
                call    Exit
        ;-------------------------------------------

    .fb_Error:
                mov     eax, fberr_msg
                call    OutAsciiZ
                jmp     short .exit

fberr_msg       db 'frabe buffer error!', 10, 0

OpenRandom:     pusha
                mov     ebx, RandomDev
                mov     ecx, O_RDONLY           ; flag
                mov     eax, SYS_open           ; ƥॳֹ
                mov     edx, 0644q              ; mode
                int     0x80
                mov     [RandomFD], eax
                popa
                ret

GetRandom:      pusha
                push    eax                     ; Хåե
                mov     eax, SYS_read           ; ƥॳֹ
                mov     ebx, [RandomFD]
                mov     ecx, esp
                mov     edx, 3                  ; ɤߤߥХȿ
                int     0x80
                pop     eax                     ; ɤ߽Ф
                mov     [esp+28], eax
                popa
                ret

CloseRandom:    push    ebx
                mov     eax, SYS_close
                mov     ebx, [RandomFD]
                int     0x80
                pop     ebx
                ret

RandomDev       db   '/dev/urandom', 0

;==============================================================
section .bss

fb_mem          resd 1
RandomFD        resd 1
