; --------------------------------------------------------------------------
; եɤ߹ߤȽ񤭤 : ե륳ԡ
; files.asm
; Jun Mizutani  5/21/2000
; --------------------------------------------------------------------------

section .bss

buf            resd   1               ; Хåե
rfn            resd   1               ; read file name
wfn            resd   1               ; write file name
rfd            resd   1               ; fd
wfd            resd   1               ; fd

section .text
global _start

%include "fcntl.inc"
%include "stdio.inc"

_start:
               pop    eax             ; ο argc
               pop    ebx             ; ޥ̾
               dec    eax             ; ºݤΰο
               cmp    eax, 2          ; ϣĤΤ
               jz     .nx
               jmp    arg_err       ; if no args jmp noarg_err
               ; ե̾ν
           .nx
               pop    ebx             ; pop filename pointer
               mov    [rfn], ebx
               pop    ebx             ; pop filename pointer
               mov    [wfn], ebx

               mov    eax, [rfn]
               call   OutAsciiZ
               mov    eax, to_msg
               call   OutAsciiZ

               mov    ebx, [rfn]
               call   fropen
               js     open_err
               mov    [rfd], eax

               mov    eax, [wfn]
               call   OutAsciiZ
               call   NewLine

               mov    ebx, [wfn]
               call   fwopen
               js     open_err
               mov    [wfd], eax
               mov    ecx, buf
.loop
               mov    ebx, [rfd]
               call   fread1
               test   eax, eax
               js     read_err
               jz     done
               mov    ebx, [wfd]
               call   fwrite1
               test   eax, eax
               js     write_err
               jmp    short .loop

done:
               mov    eax, done_msg
exit:
               push   eax
               mov    ebx, [rfd]
               call   fclose
               mov    ebx, [wfd]
               call   fclose
               pop    eax
               call   OutAsciiZ
               call   NewLine
               call   Exit

open_err:
               mov    eax, e_open_msg
               jmp    exit
read_err:
               mov    eax, e_read_msg
               jmp    exit
write_err:
               mov    eax, e_write_msg
               jmp    exit
arg_err:
               mov    eax, e_arg_msg
               jmp    exit


; ե򥪡ץ
; enter   ebx: 裱 filename
; return  eax: fd, if error then eax will be negative.
; int sys_open(const char * filename, int flags, int mode)
fropen:
               mov    ecx, O_RDONLY   ; 裲 flag
               jmp    short fopen
fwopen:
               mov    ecx, O_CREAT | O_WRONLY | O_TRUNC
fopen:         mov    eax, SYS_open   ; ƥॳֹ
               mov    edx, 0644q      ; 裳 mode
               int    0x80
               test   eax,eax         ; eax <- fd
               ret

; ե򥯥
; enter   ebx: 裱 եǥץ
; int sys_close(unsigned int fd)
fclose:        mov    eax, SYS_close  ; ƥॳֹ
               int    0x80
               ret

; ե뤫1Хɤߤ ebx : fd
; enter ebx : 裱 եǥץ
;       ecx : 裲 Хåեɥ쥹

; ssize_t sys_read(unsigned int fd, char * buf, size_t count)
fread1:        mov    eax, SYS_read   ; ƥॳֹ
               mov    edx, 1          ; 裳 ɤߤߥХȿ
               int    0x80
               ret

; ե1ХȽ񤭤
; enter ebx : 裱 եǥץ
;       ecx : 裲 Хåեɥ쥹
; ssize_t sys_write(unsigned int fd, const char * buf, size_t count)
fwrite1:       mov    eax, SYS_write  ; ƥॳֹ
               mov    edx, 1          ; 裳 񤭤ߥХȿ
               int    0x80
               ret

to_msg         db     " --> ", 0
e_open_msg     db     "Can't open such file.", 10, 0
e_read_msg     db     "Can't read such file.", 10, 0
e_write_msg    db     "Can't write such file.", 10, 0
e_arg_msg      db     "Two filenames required.", 10, 0
done_msg       db     "completed.", 10, 0

; --------------------------------------------------------------------------
